#include "sgl.h"

// typedef
typedef float (*sgGetLibVersion_Proc)( void );
typedef bool (*sgInitFromWnd_Proc)( int *pnCtrl, HWND hParentWnd );
typedef	void (*sgShowWnd_Proc)( bool bShow );
typedef bool (*sgGetShowStats_Proc)( void );
typedef void (*sgSetWndTitle_Proc)( char *szTitle );
typedef bool (*sgInitLibrary_Proc)( bool bFullScreen, int *pnCtrl, HINSTANCE hInst, int nCreateFlag );
typedef void (*sgEndLibrary_Proc)( void );
typedef void (*sgChangeDisp_Proc)( void );
typedef void (*sgGetWndSize_Proc)( int *w, int *h );
typedef bool (*sgRun_Proc)( void );
typedef void (*sgClv_Proc)( void );
typedef void (*sgCla_Proc)( void );
typedef void (*sgTellUsedMem_Proc)( DWORD *dwSys, DWORD *dwVideo );

typedef void (*sgForceMemMode_Proc)( bool bValid );
typedef int (*sgLoadBMP_Proc)( char *szFileName, DWORD dwMem );
typedef bool (*sgLoadBMPs_Proc)( char *szFileName,
		 int nXSize, int nYSize,
		 int numX, int numY, int numAll,
		 int *hArray, DWORD dwMem );
typedef int (*sgLoad_Image_Proc)( char *szFileName, DWORD dwMem );
typedef int (*sgLoad_ImageFromMem_Proc)( void *pMem, DWORD dwSize, DWORD dwMem );
typedef bool (*sgLoad_Images_Proc)( char *szFileName,
			   int nXSize, int nYSize,
			   int numX, int numY, int numAll,
			   int *hArray, DWORD dwMem );
typedef bool (*sgLoad_ImagesFromMem_Proc)( void *pMem, DWORD dwSize,
			   int nXSize, int nYSize,
			   int numX, int numY, int numAll,
			   int *hArray, DWORD dwMem );

typedef void (*sgCls_Proc)( DWORD color );
typedef void (*sgWaitForVSync_Proc)( void );
typedef void (*sgFlip_Proc)( void );
typedef void (*sgSetDrawArea_Proc)( int x0, int y0, int x1, int y1 );
typedef void (*sgDrawStringVL_Proc)( int x, int y, DWORD color, DWORD dwHeight,
									va_list vl, const char *format );
typedef int (*sgGetFPS_Proc)( void );

typedef void (*sgGetImageSize_Proc)( int nHandle, int *width, int *height );
typedef void (*sgSetBlendMode_Proc)( int mode, int value );

typedef void (*sgDrawLine_Proc)( int x0, int y0, int x1, int y1, DWORD color );
typedef void (*sgDrawBox_Proc)( int x0, int y0 , int x1, int y1, DWORD color );
typedef void (*sgDraw_Proc)( int nHandle, int x, int y );
typedef void (*sgDrawTh_Proc)( int nHandle, int x, int y );
//typedef void (*sgDrawExp_Proc)( int nHandle, int x, int y, float xScale, float yScale );
//typedef void (*sgDrawExpTh_Proc)( int nHandle, int x, int y, float xScale, float yScale );
typedef void (*sgDrawRotExp_Proc)( int nHandle, int x, int y,
			 float fRot,
			 int center_x, int center_y,
			 float xScale, float yScale );
typedef void (*sgDrawRotExpTh_Proc)( int nHandle, int x, int y,
			 float fRot,
			 int center_x, int center_y,
			 float xScale, float yScale );
typedef void (*sgDrawFlex_Proc)( int nHandle,
		   int x0, int y0, int x1, int y1,
		   int x2, int y2, int x3, int y3 );
typedef void (*sgDrawFlexTh_Proc)( int nHandle,
		   int x0, int y0, int x1, int y1,
		   int x2, int y2, int x3, int y3 );

typedef void (*sgWritePixel_Proc)( int x, int y, DWORD color );
typedef DWORD (*sgReadPixel_Proc)( int x, int y );


typedef int (*sgKeyIn_Proc)( int mode );
typedef int (*sgPushKeyIn_Proc)( int mode );
typedef void (*sgGetMousePos_Proc)( int *x, int *y );
typedef int (*sgGetJoy_Proc)( int no );

typedef int (*sgLoadAudio_Proc)( char *szFileName );
typedef int (*sgLoadAudioRes_Proc)( int id, char type[4] );
typedef void (*sgPlay_Proc)( int nHandle );
typedef bool (*sgIsPlaying_Proc)( int nHandle );
typedef void (*sgStop_Proc)( int nHandle );
typedef void (*sgStopAll_Proc)( void );
typedef void (*sgSetLoop_Proc)( int nHandle, bool bValid );
typedef void (*sgSetAudioType_Proc)( int nHandle, int type );
typedef void (*sgSetVolume_Proc)( int nHandle, float volume );
typedef void (*sgSetMasterVolume_Proc)( float db );

typedef bool (*sgIsHitBits_Proc)( int hImage0, int x0, int y0, int hImage1, int x1, int x2, DWORD *color0, DWORD *color1 );
typedef void (*sgSaveBmp_Proc)( char *fileName );


// ֐|C^
sgGetLibVersion_Proc	sgGetLibVersion;
sgInitFromWnd_Proc		sgInitFromWnd;
sgShowWnd_Proc			sgShowWnd;
sgGetShowStats_Proc		sgGetShowStats;
sgSetWndTitle_Proc		sgSetWndTitle;

sgInitLibrary_Proc	sgInitLibrary;
sgEndLibrary_Proc	sgEndLibrary;
sgChangeDisp_Proc	sgChangeDisp;
sgGetWndSize_Proc	sgGetWndSize;

sgRun_Proc			sgRun;
sgClv_Proc			sgClv;
sgCla_Proc			sgCla;
sgTellUsedMem_Proc	sgTellUsedMem;

sgForceMemMode_Proc			sgForceMemMode;
sgLoadBMP_Proc sgLoadBMP;
sgLoadBMPs_Proc sgLoadBMPs;
sgLoad_Image_Proc			sgLoad_Image;;
sgLoad_ImageFromMem_Proc	sgLoad_ImageFromMem;
sgLoad_Images_Proc			sgLoad_Images;
sgLoad_ImagesFromMem_Proc	sgLoad_ImagesFromMem;

sgCls_Proc sgCls;
sgWaitForVSync_Proc sgWaitForVSync;
sgFlip_Proc sgFlip;
sgSetDrawArea_Proc sgSetDrawArea;
sgDrawStringVL_Proc sgDrawStringVL;
sgGetFPS_Proc sgGetFPS;

sgGetImageSize_Proc sgGetImageSize;
sgSetBlendMode_Proc sgSetBlendMode;
sgDrawLine_Proc sgDrawLine;
sgDrawBox_Proc sgDrawBox;
sgDraw_Proc sgDraw;
sgDrawTh_Proc sgDrawTh;
//sgDrawExp_Proc sgDrawExp;
//sgDrawExpTh_Proc sgDrawExpTh;
sgDrawFlex_Proc sgDrawFlex;
sgDrawFlexTh_Proc sgDrawFlexTh;
sgDrawRotExp_Proc sgDrawRotExp;
sgDrawRotExpTh_Proc sgDrawRotExpTh;
sgWritePixel_Proc	sgWritePixel;
sgReadPixel_Proc	sgReadPixel;

sgKeyIn_Proc sgKeyIn;
sgPushKeyIn_Proc sgPushKeyIn;
sgGetMousePos_Proc	sgGetMousePos;
sgGetJoy_Proc sgGetJoy;

sgLoadAudio_Proc sgLoadAudio;
sgLoadAudioRes_Proc sgLoadAudioRes;
sgPlay_Proc sgPlay;
sgIsPlaying_Proc sgIsPlaying;
sgStop_Proc sgStop;
sgStopAll_Proc sgStopAll;
sgSetLoop_Proc sgSetLoop;
sgSetAudioType_Proc sgSetAudioType;
sgSetVolume_Proc sgSetVolume;
sgSetMasterVolume_Proc sgSetMasterVolume;

sgIsHitBits_Proc sgIsHitBits;
sgSaveBmp_Proc sgSaveBmp;

// O[oDLLnh
HINSTANCE g_hLib;

// dll
#define SGL_LIB		"sgl2d.dll"

// ֐݃`FbN
#define CHECK_FUNC( fn ) {if(!fn){MessageBox(NULL,"function not found",#fn,MB_OK);\
return false;}}

// DLLAvP[Vɐڑ܂B
// ́ACû֐̎gpɐ旧čs˂΂Ȃ܂B
extern bool AttachLib( void )
{
	char msg[0x100];

	g_hLib = LoadLibrary( SGL_LIB );
	if ( !g_hLib )
	{
		sprintf( msg, "%s ܂B", SGL_LIB );
		MessageBox( NULL, msg, NULL, MB_OK );
		return false;
	}

	sgGetLibVersion = (sgGetLibVersion_Proc)GetProcAddress( g_hLib, "sgGetLibVersion" );
	CHECK_FUNC(sgGetLibVersion);
	sgInitFromWnd = (sgInitFromWnd_Proc)GetProcAddress( g_hLib, "sgInitFromWnd" );
	CHECK_FUNC(sgInitFromWnd);
	sgShowWnd = (sgShowWnd_Proc)GetProcAddress( g_hLib, "sgShowWnd" );
	CHECK_FUNC(sgShowWnd);
	sgGetShowStats = (sgGetShowStats_Proc)GetProcAddress( g_hLib, "sgGetShowStats" );
	CHECK_FUNC(sgGetShowStats);
	sgSetWndTitle = (sgSetWndTitle_Proc)GetProcAddress( g_hLib, "sgSetWndTitle" );
	CHECK_FUNC(sgSetWndTitle);

	sgInitLibrary = (sgInitLibrary_Proc)GetProcAddress( g_hLib, "sgInitLibrary" );
	CHECK_FUNC(sgInitLibrary);
	sgEndLibrary = (sgEndLibrary_Proc)GetProcAddress( g_hLib, "sgEndLibrary" );
	CHECK_FUNC(sgEndLibrary);
	sgChangeDisp = (sgChangeDisp_Proc)GetProcAddress( g_hLib, "sgChangeDisp" );
	CHECK_FUNC(sgChangeDisp);
	sgGetWndSize	= (sgGetWndSize_Proc)GetProcAddress( g_hLib, "sgGetWndSize" );
	CHECK_FUNC(sgGetWndSize);
	sgRun = (sgRun_Proc)GetProcAddress( g_hLib, "sgRun" );
	CHECK_FUNC(sgRun);
	sgClv = (sgClv_Proc)GetProcAddress( g_hLib, "sgClv" );
	CHECK_FUNC(sgClv);
	sgCla = (sgCla_Proc)GetProcAddress( g_hLib, "sgCla" );
	CHECK_FUNC(sgCla);
	sgTellUsedMem = (sgTellUsedMem_Proc)GetProcAddress( g_hLib, "sgTellUsedMem" );
	CHECK_FUNC(sgTellUsedMem);

	sgForceMemMode = (sgForceMemMode_Proc)GetProcAddress( g_hLib, "sgForceMemMode" );
	CHECK_FUNC(sgForceMemMode);
	sgLoadBMP = (sgLoadBMP_Proc)GetProcAddress( g_hLib, "sgLoadBMP" );
	CHECK_FUNC(sgLoadBMP);
	sgLoadBMPs = (sgLoadBMPs_Proc)GetProcAddress( g_hLib, "sgLoadBMPs" );
	CHECK_FUNC(sgLoadBMPs);
	sgLoad_Image = (sgLoad_Image_Proc)GetProcAddress( g_hLib, "sgLoad_Image" );
	CHECK_FUNC(sgLoad_Image);
	sgLoad_ImageFromMem = (sgLoad_ImageFromMem_Proc)GetProcAddress( g_hLib, "sgLoad_ImageFromMem" );
	CHECK_FUNC(sgLoad_ImageFromMem);
	sgLoad_Images = (sgLoad_Images_Proc)GetProcAddress( g_hLib, "sgLoad_Images" );
	CHECK_FUNC(sgLoad_Images);
	sgLoad_ImagesFromMem = (sgLoad_ImagesFromMem_Proc)GetProcAddress( g_hLib, "sgLoad_ImagesFromMem" );
	CHECK_FUNC(sgLoad_ImagesFromMem);

	sgCls = (sgCls_Proc)GetProcAddress( g_hLib, "sgCls" );
	CHECK_FUNC(sgCls);
	sgWaitForVSync = (sgWaitForVSync_Proc)GetProcAddress( g_hLib, "sgWaitForVSync" );
	CHECK_FUNC(sgWaitForVSync);
	sgFlip = (sgFlip_Proc)GetProcAddress( g_hLib, "sgFlip" );
	CHECK_FUNC(sgFlip);
	sgSetDrawArea = (sgSetDrawArea_Proc)GetProcAddress( g_hLib, "sgSetDrawArea" );
	CHECK_FUNC(sgSetDrawArea);
	sgDrawStringVL = (sgDrawStringVL_Proc)GetProcAddress( g_hLib, "sgDrawStringVL" );
	CHECK_FUNC(sgDrawStringVL);
	sgGetFPS = (sgGetFPS_Proc)GetProcAddress( g_hLib, "sgGetFPS" );
	CHECK_FUNC(sgGetFPS);

	sgGetImageSize  = (sgGetImageSize_Proc)GetProcAddress( g_hLib, "sgGetImageSize" );
	CHECK_FUNC(sgGetImageSize);
	sgSetBlendMode  = (sgSetBlendMode_Proc)GetProcAddress( g_hLib, "sgSetBlendMode" );
	CHECK_FUNC(sgSetBlendMode);
	sgDrawLine = (sgDrawLine_Proc)GetProcAddress( g_hLib, "sgDrawLine" );
	CHECK_FUNC(sgDrawLine);
	sgDrawBox = (sgDrawBox_Proc)GetProcAddress( g_hLib, "sgDrawBox" );
	CHECK_FUNC(sgDrawBox);
	sgDraw = (sgDraw_Proc)GetProcAddress( g_hLib, "sgDraw" );
	CHECK_FUNC(sgDraw);
	sgDrawTh = (sgDrawTh_Proc)GetProcAddress( g_hLib, "sgDrawTh" );
	CHECK_FUNC(sgDrawTh);
//	sgDrawExp = (sgDrawExp_Proc)GetProcAddress( g_hLib, "sgDrawExp" );
//	CHECK_FUNC(sgDrawExp);
//	sgDrawExpTh = (sgDrawExpTh_Proc)GetProcAddress( g_hLib, "sgDrawExpTh" );
//	CHECK_FUNC(sgDrawExpTh);
	sgDrawRotExp = (sgDrawRotExp_Proc)GetProcAddress( g_hLib, "sgDrawRotExp" );
	CHECK_FUNC(sgDrawRotExp);
	sgDrawRotExpTh = (sgDrawRotExpTh_Proc)GetProcAddress( g_hLib, "sgDrawRotExpTh" );
	CHECK_FUNC(sgDrawRotExpTh);
	sgDrawFlex = (sgDrawFlex_Proc)GetProcAddress( g_hLib, "sgDrawFlex" );
	CHECK_FUNC(sgDrawFlex);
	sgDrawFlexTh = (sgDrawFlexTh_Proc)GetProcAddress( g_hLib, "sgDrawFlexTh" );
	CHECK_FUNC(sgDrawFlexTh);
	sgWritePixel = (sgWritePixel_Proc)GetProcAddress( g_hLib, "sgWritePixel" );
	CHECK_FUNC(sgWritePixel);
	sgReadPixel = (sgReadPixel_Proc)GetProcAddress( g_hLib, "sgReadPixel" );
	CHECK_FUNC(sgReadPixel);

	sgKeyIn = (sgKeyIn_Proc)GetProcAddress( g_hLib, "sgKeyIn" );
	CHECK_FUNC(sgKeyIn);
	sgPushKeyIn = (sgPushKeyIn_Proc)GetProcAddress( g_hLib, "sgPushKeyIn" );
	CHECK_FUNC(sgPushKeyIn);
	sgGetMousePos	= (sgGetMousePos_Proc)GetProcAddress( g_hLib, "sgGetMousePos" );
	CHECK_FUNC(sgGetMousePos);
	sgGetJoy = (sgGetJoy_Proc)GetProcAddress( g_hLib, "sgGetJoy" );
	CHECK_FUNC(sgGetJoy);

	sgLoadAudio = (sgLoadAudio_Proc)GetProcAddress( g_hLib, "sgLoadAudio" );
	CHECK_FUNC(sgLoadAudio);
	sgLoadAudioRes = (sgLoadAudioRes_Proc)GetProcAddress( g_hLib, "sgLoadAudioRes" );
	CHECK_FUNC(sgLoadAudioRes);
	sgPlay = (sgPlay_Proc)GetProcAddress( g_hLib, "sgPlay" );
	CHECK_FUNC(sgPlay);
	sgIsPlaying = (sgIsPlaying_Proc)GetProcAddress( g_hLib, "sgIsPlaying" );
	CHECK_FUNC(sgIsPlaying);
	sgStop = (sgStop_Proc)GetProcAddress( g_hLib, "sgStop" );
	CHECK_FUNC(sgStop);
	sgStopAll = (sgStopAll_Proc)GetProcAddress( g_hLib, "sgStopAll" );
	CHECK_FUNC(sgStopAll);
	sgSetLoop = (sgSetLoop_Proc)GetProcAddress( g_hLib, "sgSetLoop" );
	CHECK_FUNC(sgSetLoop);
	sgSetAudioType = (sgSetAudioType_Proc)GetProcAddress( g_hLib, "sgSetAudioType" );
	CHECK_FUNC(sgSetAudioType);
	sgSetVolume =  (sgSetVolume_Proc)GetProcAddress( g_hLib, "sgSetVolume" );
	CHECK_FUNC(sgSetVolume);
	sgSetMasterVolume = (sgSetMasterVolume_Proc)GetProcAddress( g_hLib, "sgSetMasterVolume" );
	CHECK_FUNC(sgSetMasterVolume);

	sgIsHitBits = (sgIsHitBits_Proc)GetProcAddress( g_hLib, "sgIsHitBits" );
	CHECK_FUNC(sgIsHitBits);
	sgSaveBmp = (sgSaveBmp_Proc)GetProcAddress( g_hLib, "sgSaveBmp" );
	CHECK_FUNC(sgSaveBmp);

	return true;
	
}

// DLL؂藣܂B
// ̌ɁACů֐ĂяoƂ͏o܂B
extern void DetachLib( void )
{
	FreeLibrary( g_hLib );
}

/////////////////////////////////////
// c[p֐Q

float GetLibVersion()
{
	return sgGetLibVersion();
}

bool InitFromWnd( int *pnCtrl, HWND hParentWnd )
{
	if ( !AttachLib() )
		return false;

	return sgInitFromWnd( pnCtrl, hParentWnd );
}

void ShowWnd( bool bShow )
{
	sgShowWnd( bShow );
}

bool GetShowStats()
{
	return sgGetShowStats();
}

void SetWndTitle( char *szTitle )
{
	sgSetWndTitle( szTitle );
}

///////////////////////////////////////////////////////////////////
// ʏ̃Q[p֐Q

bool InitLibrary( bool bFullScreen, int *pnCtrl, HINSTANCE hInst )
{
	if ( !AttachLib() ) return false;
	if ( !hInst )	hInst	= g_hLib;
	return sgInitLibrary( bFullScreen, pnCtrl, hInst, 0 );
}

void EndLibrary( void )
{
	sgEndLibrary();
	DetachLib();
}

void ChangeDisp( void )
{
	sgChangeDisp();
}

void GetWndSize( int *w, int *h )
{
	sgGetWndSize( w, h );
}

bool Run( void )
{
	return sgRun();
}

void Clv()
{
	sgClv();
}

void Cla()
{
	sgCla();
}

void TellUsedMem( DWORD *dwSys, DWORD *dwVideo )
{
	sgTellUsedMem( dwSys, dwVideo );
}



void ForceMemMode( bool bValid )
{
	sgForceMemMode( bValid );
}

int LoadBMP( char *szFileName, DWORD dwMem )
{
	return sgLoadBMP( szFileName, dwMem );
}

bool LoadBMPs( char *szFileName,
		 int nXSize, int nYSize,
		 int numX, int numY, int numAll,
		 int *hArray, DWORD dwMem )
{
	return sgLoadBMPs( szFileName,
		nXSize, nYSize,
		numX, numY, numAll,
		hArray, dwMem );
}

int Load_Image( char *szFileName, DWORD dwMem )
{
	return sgLoad_Image( szFileName, dwMem );
}

int Load_ImageFromMem( void *pMem, DWORD dwSize, DWORD dwMem )
{
	return sgLoad_ImageFromMem( pMem, dwSize, dwMem );
}

bool Load_Images( char *szFileName,
			   int nXSize, int nYSize,
			   int numX, int numY, int numAll,
			   int *hArray, DWORD dwMem )
{
	return sgLoad_Images( szFileName,
		nXSize, nYSize,
		numX, numY, numAll,
		hArray, dwMem );
}

bool Load_ImagesFromMem( void *pMem, DWORD dwSize,
			   int nXSize, int nYSize,
			   int numX, int numY, int numAll,
			   int *hArray, DWORD dwMem )
{
	return sgLoad_ImagesFromMem(
		pMem, dwSize,
		nXSize, nYSize,
		numX, numY, numAll,
		hArray, dwMem );
}





void Cls( DWORD color )
{
	sgCls( color );
}
	
void WaitForVSync( void )
{
	sgWaitForVSync();
}

void Flip( void )
{
	sgFlip();
}

void DrawString( int x, int y, DWORD color, DWORD dwHeight, const char *format, ... )
{
	va_list vl;

	va_start( vl, format );
	sgDrawStringVL( x, y, color, dwHeight, vl, format );
	va_end( vl );

}

int GetFPS( void )
{
	return sgGetFPS();
}

///////////////////////////////////////////
// `
void GetImageSize( int nHandle, int *width, int *height )
{
	sgGetImageSize( nHandle, width, height );
}

void SetBlendMode( int mode, int value )
{
	sgSetBlendMode( mode, value );
}

void SetDrawArea( int x0, int y0, int x1, int y1 )
{
	sgSetDrawArea( x0, y0, x1, y1 );
}

void DrawLine( int x0, int y0, int x1, int y1, DWORD color )
{
	sgDrawLine( x0, y0, x1, y1, color );
}

void DrawBox( int x0, int y0 , int x1, int y1, DWORD color )
{
	sgDrawBox( x0, y0, x1, y1, color );
}

void Draw( int nHandle, int x, int y )
{
	sgDraw( nHandle, x, y );
}

void DrawTh( int nHandle, int x, int y )
{
	sgDrawTh( nHandle, x, y );
}

/*
void DrawExp( int nHandle, int x, int y, float xScale, float yScale )
{
	sgDrawExp( nHandle, x, y, xScale, yScale );
}

void DrawExpTh( int nHandle, int x, int y, float xScale, float yScale )
{
	sgDrawExpTh( nHandle, x, y, xScale, yScale );
}
*/

void DrawRotExp( int nHandle, int x, int y,
			 float fRot,
			 int center_x, int center_y,
			 float xScale, float yScale )
{
	sgDrawRotExp( nHandle,
		x, y,
		fRot,
		center_x, center_y,
		xScale, yScale );
}

void DrawRotExpTh( int nHandle, int x, int y,
			 float fRot,
			 int center_x, int center_y,
			 float xScale, float yScale )
{
	sgDrawRotExpTh( nHandle,
		x, y,
		fRot,
		center_x, center_y,
		xScale, yScale );
}



void DrawFlex( int nHandle,
		   int x0, int y0, int x1, int y1,
		   int x2, int y2, int x3, int y3 )
{
	sgDrawFlex( nHandle,
		x0, y0, x1, y1,
		x2, y2, x3, y3 );
}

void DrawFlexTh( int nHandle,
		   int x0, int y0, int x1, int y1,
		   int x2, int y2, int x3, int y3 )
{
	sgDrawFlexTh( nHandle,
		x0, y0, x1, y1,
		x2, y2, x3, y3 );
}

void WritePixel( int x, int y, DWORD color )
{
	sgWritePixel( x, y, color );
}

DWORD ReadPixel( int x, int y )
{
	return sgReadPixel( x, y );
}


/////////////////////////////////////////////
// L[

int KeyIn( int mode )
{
	return sgKeyIn( mode );
}

int PushKeyIn( int mode )
{
	return sgPushKeyIn( mode );
}

void GetMousePos( int *px, int *py )
{
	sgGetMousePos( px, py );
}

int GetJoy( int No )
{
	return sgGetJoy( No );
}


///////////////////////////////////////////
// 
int LoadAudio( char *fileName )
{
	return sgLoadAudio( fileName );
}

int LoadAudioRes( int id, char type[4] )
{
	return sgLoadAudioRes( id, type );
}

void Play( int nHandle )
{
	sgPlay( nHandle );
}

bool IsPlaying( int nHandle )
{
	return sgIsPlaying( nHandle );
}

void Stop( int nHandle )
{
	sgStop( nHandle );
}

void StopAll( void )
{
	sgStopAll();
}

void SetLoop( int nHandle, bool bValid )
{
	sgSetLoop( nHandle, bValid );
}

void SetAudioType( int nHandle, int type )
{
	sgSetAudioType( nHandle, type );
}

void SetVolume( int nHandle, float volume )
{
	sgSetVolume( nHandle, volume );
}

void SetMasterVolume( float db )
{
	sgSetMasterVolume( db );
}

///////////////////////////////////////
// ̑

extern bool IsHitBits( int hImage0, int x0, int y0,
		   int hImage1, int x1, int y1,
		   DWORD *pColor0, DWORD *pColor1 )
{
	return sgIsHitBits( hImage0, x0, y0,
		hImage1, x1, y1,
		pColor0, pColor1 );
}

extern void SaveBmp( char *fileName )
{
	sgSaveBmp( fileName );
}
