/*********************************
		math2d_lib.cpp
		since 2004/12/18
		update 2005/12/22
*********************************/

// CN[ḧ
#include "math2d_lib.h"

/*=====================================================


				QxNg


=====================================================*/

// QcxNg̘a( v0+v1 )
VECTOR2 VECTOR2::operator+ ( VECTOR2 v1 )
{
	VECTOR2 ret; // ߂l

	// eƂɘa߂B
	ret.x = x + v1.x;
	ret.y = y + v1.y;

	return ret;
}

// QcxNg̍( v0-v1 )
VECTOR2 VECTOR2::operator- ( VECTOR2 v1 )
{
	VECTOR2 ret; // ߂l

	// eƂɍ߂B
	ret.x = x - v1.x;
	ret.y = y - v1.y;

	return ret;
}

// QcxNg̃}CiX( -v )
VECTOR2 VECTOR2::operator - ()
{
	VECTOR2 ret; // ߂l

	ret.x = -x;
	ret.y = -y;

	return ret;
}

// ȗ`̃I[o[[h
VECTOR2 VECTOR2::operator += ( VECTOR2 b )
{
	x += b.x;
	y += b.y;

	return *this;
}

// ȗ`̃I[o[[h
VECTOR2 VECTOR2::operator -= ( VECTOR2 b )
{
	x -= b.x;
	y -= b.y;

	return *this;
}

// QcxNg̃XJ[{(av)
VECTOR2 operator* ( float a, VECTOR2 &v )
{
	VECTOR2 ret; // ߂l

	// eƂɃXJ[{߂B
	ret.x = a * v.x;
	ret.y = a * v.y;

	return ret;
}

// QcxNg̃XJ[{(va)
VECTOR2 VECTOR2::operator* ( float a )
{
	VECTOR2 ret; // ߂l

	// eƂɃXJ[{߂B
	ret.x = x * a;
	ret.y = y * a;

	return ret;
}

// QcxNg̃XJ[{(va)(ȗ`)
VECTOR2 VECTOR2::operator*= ( float a )
{
	// eƂɃXJ[{߂B
	x = x * a;
	y = y * a;

	return *this;
}

// QcxNg̃XJ[ɂ鏜Z( v/a )
VECTOR2 VECTOR2::operator / (float a )
{
	VECTOR2 ret; // ߂l
	float	s;

	// eƂɃXJ[ɂ鏜Z߂B
	s		= 1.0F / a;
	ret.x	= x * s;
	ret.y	= y * s;

	return ret;
}

VECTOR2 VECTOR2::operator /= ( float a )
{
	float	s;

	// eƂɃXJ[ɂ鏜Z߂B
	s		= 1.0F / a;
	x		*= s;
	y		*= s;

	return *this;
}

// QcxNg̑傫
float SizeOfVector2( VECTOR2 *v )
{
	float size_sq; // 傫̂Q
	float size; // 傫

	size_sq = v->x * v->x + v->y * v->y; // 傫̂Q̎
	size = sqrtf( size_sq ); // 傫̂Q̕傫

	return size;
}

// QcxNg̑傫̂Q
float SizeSqOfVector2( VECTOR2 *v )
{
	// 傫̂Q̎
	return v->x * v->x + v->y * v->y;
}

// QcxNg̐K(PʃxNgɂB)
VECTOR2 NormalizeVector2( VECTOR2 *v )
{
	float size;
	VECTOR2 ret;

	// 傫߂B
	size = SizeOfVector2( v );
	// e傫ŊB
	ret.x = v->x / size;
	ret.y = v->y / size;

	return ret;
}

// QcxNg̓( v0Ev1 )
float DotProduct2( VECTOR2 *v0, VECTOR2 *v1 )
{
	// ς̌
	return v0->x * v1->x + v0->y * v1->y;
}

// QcxNg̊O( v0~v1 )
float CrossProduct2( VECTOR2 *v0, VECTOR2 *v1 )
{
	// Oς̌
	return v0->x * v1->y - v1->x * v0->y;
}

// QcxNg̊O( v0~v1 )(Zq̃I[o[[h)
float operator * ( VECTOR2 &v0, VECTOR2 &v1 )
{
	return CrossProduct2( &v0, &v1 );
}

// QcxNgcos
float CosineTheta2( VECTOR2 *v0, VECTOR2 *v1 )
{
	float size_v0, size_v1; // exNg̑傫
	float c; // cos

	// exNg̑傫Aꂼꋁ߂B
	size_v0 = SizeOfVector2( v0 );
	size_v1 = SizeOfVector2( v1 );
	// cosƂ̎
	c = DotProduct2( v0, v1 ) / size_v0 / size_v1;

	return c;
}

// QcxNgsin
float SineTheta2( VECTOR2 *v0, VECTOR2 *v1 )
{
	float size_v0, size_v1; // exNg̑傫
	float s; // sin

	// exNg̑傫Aꂼꋁ߂B
	size_v0 = SizeOfVector2( v0 );
	size_v1 = SizeOfVector2( v1 );
	// sinƂ̎
	s = CrossProduct2( v0, v1 ) / size_v0 / size_v1;

	return s;
}


// Qc̐ˉexNg( v0v1 )
VECTOR2 ProjectionVector2( VECTOR2 *v0, VECTOR2 *v1 )
{
	// ˉexNǧ
	return ( DotProduct2( v0, v1 ) / SizeSqOfVector2( v1 ) ) * (*v1);
}

// Qc̎ˉexNg( v0Av1ɐȃxNg߂B )
VECTOR2 PerpendicularVector2( VECTOR2 *v0, VECTOR2 *v1 )
{
	// ˉexNǧ
	return *v0 - ProjectionVector2( v0, v1 );
}

// Qc̓_ƒ̋
// Fp = p0 + tu  _q ̋
float DistanceFromPointToLine2( VECTOR2 *q, VECTOR2 *p0, VECTOR2 *u )
{
	VECTOR2 a, h; // xNgqp0AˉexNg
	float size; // ˉexNg̑傫

	a = (*p0) - (*q); // xNgqp0߂B
	h = PerpendicularVector2( &a, u ); // ˉexNg߂B
	size = SizeOfVector2( &h ); // ˉexNg̑傫

	return size;
}

// Qc̓_Ɛ̋
// Fv0  v1 ƁA_q ̋
float DistanceFromPointToLimitedLine2( VECTOR2 *q, VECTOR2 *v0, VECTOR2 *v1 )
{
	VECTOR2 direction, distance;
	float dist_size;

	// v0 
	direction = *v0 - *v1;
	distance = *q - *v0;
	if ( DotProduct2( &direction, &distance ) >= 0.0 )
	{
		// _q ́Av0 ɂ̂ŁA
		// Q_Ԃ̋ɋAB
		dist_size = SizeOfVector2( &distance );

		return dist_size;
	}

	// v1 
	direction = *v1 - *v0;
	distance = *q - *v1;
	if ( DotProduct2( &direction, &distance ) >= 0.0 )
	{
		// _q ́Av1 ɂ̂ŁA
		// Q_Ԃ̋ɋAB
		dist_size = SizeOfVector2( &distance );

		return dist_size;
	}

	// _q ́Av0 v1 ̊Ԃɂ̂ŁA
	// _ƒ̋ɋAB
	dist_size = DistanceFromPointToLine2( q, v0, &direction );

	return dist_size;
}

// Qc̐xNg( vɐȃxNg )
VECTOR2 CrossVector2( VECTOR2 *v )
{
	VECTOR2 ret;

	// (x,y)(-y,x)
	ret.x = - v->y;
	ret.y = v->x;

	return ret;
}

// QĉRp`̓
// p0, p1, p2 F Op`
// v : _
// ɂȂAtrue ԂBOȂAfalse ԂB
bool IsInsideTriangle2( VECTOR2 *p0, VECTOR2 *p1, VECTOR2 *p2, VECTOR2 *v )
{
	VECTOR2 edge;		// 
	VECTOR2 normal;		// @xNg(ȃxNg)
	VECTOR2 point;		// WϊꂽOp`̂P_
	VECTOR2 v2;			// Wϊꂽ_
	float dp0, dp1;	// 

	// _p0ɂB
	// p2p0ŁAׂ
	edge = (*p2) - (*p0);
	normal = CrossVector2( &edge );
	point = (*p1) - (*p0);
	v2 = (*v) - (*p0);
	dp0 = DotProduct2( &normal, &point );
	dp1 = DotProduct2( &normal, &v2 );
	if ( dp0 * dp1 < 0.0 )
	{
		// ςٕ̕Oɂ
		return false;
	}

	// _p1ɂB
	// p1p0ŁAׂ
	edge = (*p0) - (*p1);
	normal = CrossVector2( &edge );
	point = (*p2) - (*p1);
	v2 = (*v) - (*p1);
	dp0 = DotProduct2( &normal, &point );
	dp1 = DotProduct2( &normal, &v2 );
	if ( dp0 * dp1 < 0.0 )
	{
		// ςٕ̕Oɂ
		return false;
	}

	// _p2ɂB
	// p2p1ŁAׂ
	edge = (*p1) - (*p2);
	normal = CrossVector2( &edge );
	point = (*p0) - (*p2);
	v2 = (*v) - (*p2);
	dp0 = DotProduct2( &normal, &point );
	dp1 = DotProduct2( &normal, &v2 );
	if ( dp0 * dp1 < 0.0 )
	{
		// ςٕ̕Oɂ
		return false;
	}

	// SĂ̓ςɂ邱Ƃm
	return true;
}






/*=====================================================


				Qs


=====================================================*/

// Qs̘a( A + B )
MATRIX2 operator +( MATRIX2 A, MATRIX2 B )
{
	MATRIX2 ret;
	int i, j;

	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			ret.m[i][j] = A.m[i][j] + B.m[i][j];
		}
	}

	return ret;
}

// Qs̍( A - B )
MATRIX2 operator -( MATRIX2 A, MATRIX2 B )
{
	MATRIX2 ret;
	int i, j;

	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			ret.m[i][j] = A.m[i][j] - B.m[i][j];
		}
	}

	return ret;
}

// Qs̃}CiX( -A )
MATRIX2 operator - ( MATRIX2 &A )
{
	MATRIX2 ret;
	int i, j;

	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			ret.m[i][j] = - A.m[i][j];
		}
	}

	return ret;
}

// Qs̃XJ[{( aA )
MATRIX2 operator *( float a, MATRIX2 A )
{
	MATRIX2 ret;
	int i, j;

	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			ret.m[i][j] = a * A.m[i][j];
		}
	}

	return ret;
}

// Qs̏Z( A~B )
MATRIX2 MatrixMultiply2( MATRIX2 &A, MATRIX2 &B )
{
	MATRIX2 ret;
	float m;
	int i, j, k;

	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			m = 0.0;
			for ( k = 0 ; k < 2 ; k++ )
			{
				m += A.m[i][k] * B.m[k][j];
			}
			ret.m[i][j] = m;
		}
	}

	return ret;
}

// Qs̏Z( A~B )(Zq̃I[o[[h)
MATRIX2 operator * ( MATRIX2 &A, MATRIX2 &B )
{
	return MatrixMultiply2( A, B );
}

// PʂQsԂB
MATRIX2 MatrixIdentity2( void )
{
	int i, j;
	MATRIX2 ret;

	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			if ( i == j )
			{
				ret.m[i][j] = 1;
			}
			else
			{
				ret.m[i][j] = 0;
			}
		}
	}

	return ret;
}

// Qs̓]us
MATRIX2 MatrixTranspose2( MATRIX2 A )
{
	MATRIX2 ret;
	int i, j;

	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			ret.m[i][j] = A.m[j][i];
		}
	}

	return ret;
}

// Qs̍s
float MatrixDeterminant2( MATRIX2 A )
{
	float det;

	// ad - bc
	det = A.m[0][0] * A.m[1][1] - A.m[0][1] * A.m[1][0];

	return det;
}

// Qs̋ts
MATRIX2 MatrixInverse2( MATRIX2 A )
{
	float det;			// s񎮂̒l
	MATRIX2 ret;		// ߂l

	det = MatrixDeterminant2( A );
	if ( det == 0.0 )
	{
		return A;
	}

	// Qs̋tš
	ret.m[0][0] = A.m[1][1];
	ret.m[1][0] = -A.m[1][0];
	ret.m[0][1] = -A.m[0][1];
	ret.m[1][1] = A.m[0][0];
	ret = ( 1.0f / det ) * ret;

	return ret;
}

// Qs̋ts
MATRIX2 operator ~( MATRIX2 &A )
{
	return MatrixInverse2( A );
}




/*=====================================================


				Rs


=====================================================*/

// Rs̘a( A + B )
MATRIX3 operator +( MATRIX3 A, MATRIX3 B )
{
	MATRIX3 ret;
	int i, j;

	for ( i = 0 ; i < 3 ; i++ )
	{
		for ( j = 0 ; j < 3 ; j++ )
		{
			ret.m[i][j] = A.m[i][j] + B.m[i][j];
		}
	}

	return ret;
}

// Rs̍( A - B )
MATRIX3 operator -( MATRIX3 A, MATRIX3 B )
{
	MATRIX3 ret;
	int i, j;

	for ( i = 0 ; i < 3 ; i++ )
	{
		for ( j = 0 ; j < 3 ; j++ )
		{
			ret.m[i][j] = A.m[i][j] - B.m[i][j];
		}
	}

	return ret;
}

// Rs̃}CiX( -A )
MATRIX3 operator - ( MATRIX3 &A )
{
	MATRIX3 ret;
	int i, j;

	for ( i = 0 ; i < 3 ; i++ )
	{
		for ( j = 0 ; j < 3 ; j++ )
		{
			ret.m[i][j] = -A.m[i][j];
		}
	}

	return ret;
}

// Rs̃XJ[{( aA )
MATRIX3 operator *( float a, MATRIX3 A )
{
	MATRIX3 ret;
	int i, j;

	for ( i = 0 ; i < 3 ; i++ )
	{
		for ( j = 0 ; j < 3 ; j++ )
		{
			ret.m[i][j] = a * A.m[i][j];
		}
	}

	return ret;
}

// Rs̏Z( A~B )
MATRIX3 MatrixMultiply3( MATRIX3 &A, MATRIX3 &B )
{
	MATRIX3 ret;
	float m;
	int i, j, k;

	for ( i = 0 ; i < 3 ; i++ )
	{
		for ( j = 0 ; j < 3 ; j++ )
		{
			m = 0.0;
			for ( k = 0 ; k < 3 ; k++ )
			{
				m += A.m[i][k] * B.m[k][j];
			}
			ret.m[i][j] = m;
		}
	}

	return ret;
}

// Rs̏Z( A~B )
MATRIX3 operator * ( MATRIX3 &A, MATRIX3 &B )
{
	return MatrixMultiply3( A, B );
}

// PʂRsԂB
MATRIX3 MatrixIdentity3( void )
{
	int i, j;
	MATRIX3 ret;

	for ( i = 0 ; i < 3 ; i++ )
	{
		for ( j = 0 ; j < 3 ; j++ )
		{
			if ( i == j )
			{
				ret.m[i][j] = 1;
			}
			else
			{
				ret.m[i][j] = 0;
			}
		}
	}

	return ret;
}

// Rs̓]us
MATRIX3 MatrixTranspose3( MATRIX3 A )
{
	MATRIX3 ret;
	int i, j;

	for ( i = 0 ; i < 3 ; i++ )
	{
		for ( j = 0 ; j < 3 ; j++ )
		{
			ret.m[i][j] = A.m[j][i];
		}
	}

	return ret;
}

// Rs̍s
float MatrixDeterminant3( MATRIX3 A )
{
	float det;

	// TX̌
	det = ( A.m[0][0] * A.m[1][1] * A.m[2][2] +
			A.m[0][2] * A.m[1][0] * A.m[2][1] +
			A.m[0][1] * A.m[1][2] * A.m[2][0] )
			-
		  ( A.m[0][0] * A.m[1][2] * A.m[2][1] +
			A.m[0][2] * A.m[1][1] * A.m[2][0] + 
			A.m[0][1] * A.m[1][0] * A.m[2][2] );

	return det;
}

// Rs̋ts
MATRIX3 MatrixInverse3( MATRIX3 A )
{
	float det;			// s񎮂̒l
	MATRIX2 mat2;	// ]qvZp
	MATRIX3 ret;		// ߂l

	det = MatrixDeterminant3( A );
	if ( det == 0.0 )
	{
		return A;
	}

	// Ps
	mat2 = MATRIX2( A.m[1][1], A.m[1][2],
					   A.m[2][1], A.m[2][2] );
	ret.m[0][0] = MatrixDeterminant2( mat2 );
	mat2 = MATRIX2( A.m[1][0], A.m[1][2],
					   A.m[2][0], A.m[2][2] );
	ret.m[0][1] = -MatrixDeterminant2( mat2 );
	mat2 = MATRIX2( A.m[1][0], A.m[1][1],
					   A.m[2][0], A.m[2][1] );
	ret.m[0][2] = MatrixDeterminant2( mat2 );

	// Qs
	mat2 = MATRIX2( A.m[0][1], A.m[0][2],
					   A.m[2][1], A.m[2][2] );
	ret.m[1][0] = -MatrixDeterminant2( mat2 );
	mat2 = MATRIX2( A.m[0][0], A.m[0][2],
					   A.m[2][0], A.m[2][2] );
	ret.m[1][1] = MatrixDeterminant2( mat2 );
	mat2 = MATRIX2( A.m[0][0], A.m[0][1],
					   A.m[2][0], A.m[2][1] );
	ret.m[1][2] = -MatrixDeterminant2( mat2 );

	// Rs
	mat2 = MATRIX2( A.m[0][1], A.m[0][2],
					   A.m[1][1], A.m[1][2] );
	ret.m[2][0] = MatrixDeterminant2( mat2 );
	mat2 = MATRIX2( A.m[0][0], A.m[0][2],
					   A.m[1][0], A.m[1][2] );
	ret.m[2][1] = -MatrixDeterminant2( mat2 );
	mat2 = MATRIX2( A.m[0][0], A.m[0][1],
					   A.m[1][0], A.m[1][1] );
	ret.m[2][2] = MatrixDeterminant2( mat2 );

	ret = MatrixTranspose3( ret ); // ]us߂B
	ret = ( 1.0f / det ) * ret; // s񎮂ŊB

	return ret;
}

// Rs̋ts
MATRIX3 operator ~( MATRIX3 &A )
{
	return MatrixInverse3( A );
}





/*=====================================================


				ϊ


=====================================================*/

// QxNg~Qs
VECTOR2 MultiplyVectorByMatrix2( VECTOR2 &v, MATRIX2 &m )
{
	VECTOR2 ret;

	ret.x = v.x * m.m[0][0] + v.y * m.m[1][0];
	ret.y = v.x * m.m[0][1] + v.y * m.m[1][1];

	return ret;
}

// QxNg~Qs(Zq̃I[o[[h)
VECTOR2 operator * ( VECTOR2 &v, MATRIX2 &m )
{
	return MultiplyVectorByMatrix2( v, m );
}

// QxNg̃AtBϊ
VECTOR2 AffineTransform2( VECTOR2 &v, MATRIX3 &m )
{
	VECTOR2 ret;

	ret.x = v.x * m.m[0][0] + v.y * m.m[1][0] + m.m[2][0];
	ret.y = v.x * m.m[0][1] + v.y * m.m[1][1] + m.m[2][1];

	return ret;
}

// QxNg̃AtBϊ̃I[o[[h
VECTOR2 operator *( VECTOR2 &v, MATRIX3 &m )
{
	return AffineTransform2( v, m );
}

// Q̃XP[Os
// sx : ̃XP[O
// sy : ̃XP[O
// XP[OsԂ
MATRIX2 MatrixScale2( float sx, float sy )
{
	MATRIX2 ret;

	ret = MatrixIdentity2();
	ret.m[0][0] *= sx;
	ret.m[1][1] *= sy;

	return ret;
}

// Q̉]s
MATRIX2 MatrixRotation2( float theta )
{
	MATRIX2 ret;
	float c, s;
	float *pC, *pS;

	pC	= &c;
	pS	= &s;

	FASTCOSSIN( theta, pC, pS );
	ret = MATRIX2(
		c, s,
		-s, c );


	return ret;
}

// Q̕sړs
MATRIX3 MatrixTranslate2( VECTOR2 trans )
{
	MATRIX3 ret;

	ret = MatrixIdentity3();
	ret.m[2][0] = trans.x;
	ret.m[2][1] = trans.y;

	return ret;
}

// Q̃AtBϊs𐶐
MATRIX3 MatrixAffine2( MATRIX2 m, VECTOR2 trans )
{
	MATRIX3 ret;
	int i, j;

	ret = MatrixIdentity3();
	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			ret.m[i][j] = m.m[i][j];
		}
	}

	ret.m[2][0] = trans.x;
	ret.m[2][1] = trans.y;

	return ret;
}

// Q̂sqrϊs쐬
// XP[O~]s~sړs
// sx : XP[O
// sy : XP[O
// theta : ]p
// trans : sړ
// KȂĂǂB
MATRIX3 MatrixTRS2( float sx, float sy, float theta, VECTOR2 trans )
{
	MATRIX2 matScale;
	MATRIX2 matRot;
	MATRIX2 matTemp2;
	MATRIX3 ret;

	matScale = MatrixScale2( sx, sy );
	matRot = MatrixRotation2( theta );
	matTemp2 = MatrixMultiply2( matScale, matRot );
	ret = MatrixAffine2( matTemp2, trans );

	return ret;
}


// Q̐ˉes
MATRIX2 MatrixProjection2( VECTOR2 a )
{
	MATRIX2 ret;
	float size_square;

	size_square = a.x * a.x + a.y * a.y;
	ret = ( 1.0f / size_square ) * MATRIX2(
		a.x * a.x, a.x * a.y,
		a.y * a.x, a.y * a.y );

	return ret;
}

// Kspĉ]s쐬B
// xNg̕ɉ]s
// toward : ÕxNg
// right : ̉Ẽ̕xNg
// Ftoward̕ցAE̕ɌB
MATRIX2 MatrixToward2( VECTOR2 toward, VECTOR2 right )
{
	VECTOR2 l_toward, l_right;
	MATRIX2 ret;

	// ÔߐKB
	l_toward = NormalizeVector2( &toward );

	// ExNg߂B
	l_right = PerpendicularVector2( &right, &toward );

	// ÔߐKB
	l_right	= NormalizeVector2( &l_right );

	// Wϊs
	ret = MATRIX2(
		l_right.x, l_right.y,
		l_toward.x, l_toward.y );

	return ret;
}




/*=====================================================


			AȐ̕


=====================================================*/

// ̕
// v0, v1F[_w肷
// tFp[^(O`P)w肷
// ߂lFԂꂽxNg(R)
VECTOR2 VectorLerp2( VECTOR2 v0, VECTOR2 v1, float t )
{
	VECTOR2		ret;

	// `Ԃ̎F(1-t)V0+tV1
	ret = ( 1 - t ) * v0 + t * v1;

	return ret;
}

// ܂̕
// numF_̌
// pVF_̔zw肷
// tFp[^(O`num-1)w肷
// t̒lFO`PPڂƂQڂԂA
// @@@ @P`QQڂƂRڂԂ
// ߂lFԂꂽxNg(R)
VECTOR2 VectorLerps2( int num, VECTOR2 *pV, float t )
{
	VECTOR2 ret;
	int		no;
	float	param;

	no		= (int)t;									// Y̐o
	param	= t - (float)no;							// O`Pɂ
	ret		= VectorLerp2( pV[no], pV[no+1], param );	// `

	return ret;
}


// OWF
// numF_̌w肷
// pX, pYF_̂W̔zAyтW̔zw肷
// XFWw肷
// ߂lFXŎw肳ꂽxWɑΉyWԂ
float Lagurange( int num, float *pX, float *pY, float X )
{
	float		sum, temp;
	int			i, j;

	sum = 0.0F;

	for ( i = 0 ; i < num ; i++ )
	{
		temp = pY[i];

		for ( j = 0 ; j < num ; j++ )
		{
			if ( i != j )
			{
				temp *= ( X - pX[j] ) / ( pX[i] - pX[j] );
			}
		}

		sum += temp;
	}

	return sum;
}



// Lg}Ȑ
// pVFQ̒[_̈ʒuxNgw肷
// pV2FQ̒[_̐̒[_̈ʒuxNgw肷
// tFp[^(O`P)w肷
// ߂lFԂꂽxNg(Q)
VECTOR2 CatmullRom2( VECTOR2 pV[2], VECTOR2 pV2[2], float t )
{
	float		x, y;

	x	= CatmullRom1( pV2[0].x, pV[0].x, pV[1].y, pV2[1].x, t );
	y	= CatmullRom1( pV2[0].y, pV[0].y, pV[1].y, pV2[1].y, t );

	return VECTOR2( x, y );
}

// A_̃Lg}Ȑ
// numFžw肷
// pVF[_̈ʒuxNg̔zw肷
// tFp[^(O`num-1)w肷
// t̒lFO`PPڂƂQڂԂA
// @@@ @P`QQڂƂRڂԂ
// ߂lFԂꂽxNg(Q)
VECTOR2 CatmullRoms2( int num, VECTOR2 *pV, float t, bool bLoop )
{
	VECTOR2 retInvalid;
	VECTOR2	p[2], p2[2];
	int		no;
	float	param;

    // G[`FbN
	if ( num <= 0 )
		return retInvalid;

	// ͈͂؂
	if ( t < 0.0F )
	{
		t = 0.0F;
	}
	if ( bLoop )
	{
		if ( t > (float)num )
		{
			t = (float)num;
		}
	}
	else
	{
		if ( t > (float)(num-1) )
		{
			t = (float)(num-1);
		}
	}

	// Y̐o
	no		= (int)t;									

	// O`Pɂ
	param	= t - (float)no;							

	// Lg}
	// _̌ɂꍇ킯
	if ( num == 1 )
	{
		return pV[0];
	}
	else if ( num == 2 )
	{
		if ( no < 1 )
            return VectorLerp2( pV[0], pV[1], param );
		else if ( bLoop )
			return VectorLerp2( pV[1], pV[0], param );
	}
	else if ( num == 3 )
	{
		if ( no < 1 )
		{
			if ( bLoop )
				p2[0]	= pV[2];
			else
				p2[0]	= pV[0];
			p[0]	= pV[0];
			p[1]	= pV[1];
            p2[1]	= pV[2];
		}
		else if ( no < 2 )
		{
			p2[0]	= pV[0];
			p[0]	= pV[1];
			p[1]	= pV[2];
			if ( bLoop )
				p2[1]	= pV[0];
			else
                p2[1]	= pV[2];
		}
		else // if ( no > 2 )
		if ( bLoop )
		{
			p2[0]	= pV[1];
			p[0]	= pV[2];
			p[1]	= pV[0];
			p2[1]	= pV[1];
		}

		return CatmullRom2( p, p2, param );
	}
	else// if ( num > 3 )
	{
		if ( no == 0 )
		{
			if ( bLoop )
				p2[0] = pV[num-1];
			else
                p2[0]	= pV[0];
			p[0]	= pV[0];
			p[1]	= pV[1];
            p2[1]	= pV[2];
		}
		else if ( no >= num - 1 )
		{
			if ( !bLoop )
                return pV[no];
			else
			{
				p2[0]	= pV[num-2];
				p[0]	= pV[num-1];
				p[1]	= pV[0];
				p2[1]	= pV[1];
			}
		}
		else if ( no >= num - 2 )
		{
			p2[0]	= pV[num-3];
			p[0]	= pV[num-2];
			p[1]	= pV[num-1];
			if ( bLoop )
				p2[1] = pV[0];
			else
                p2[1]	= pV[num-1];
		}
		else
		{
			p2[0]	= pV[no-1];
			p[0]	= pV[no];
			p[1]	= pV[no+1];
			p2[1]	= pV[no+2];
		}

		return CatmullRom2( p, p2, param );
	}

	return retInvalid;

}









/*=====================================================


				E{[


=====================================================*/

// AABROBR
AABR::operator OBR()
{
	OBR			ret;

	ret.center = ( minimum + maximum ) * 0.5F;
	ret.axis[0] = VECTOR2( 1, 0 );
	ret.axis[1] = VECTOR2( 0, 1 );
	ret.extent = ( maximum - minimum ) * 0.5F;

	return ret;
}

// OBR̕ϊ
OBR OBRMultiplyByMatrix3( OBR &box, MATRIX3 &mat )
{
	OBR			ret;
	MATRIX3		matN;
	MATRIX2		matRot;
	int			i, j;

	matN		= MatrixTranspose3( ~mat );
	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			matRot.m[i][j] = matN.m[i][j];
		}
	}
	ret.center	= box.center * mat;
	for ( i = 0 ; i < 2 ; i++ )
	{
		ret.axis[i] = box.axis[i] * matRot;
	}
	ret.extent	= box.extent;

	return ret;
}
	
// OBR̕ϊ(Zq̃I[o[[h)
OBR operator * ( OBR &box, MATRIX3 &mat )
{
	return OBRMultiplyByMatrix3( box, mat );
}


// BSPHERĚ
bool IntersectBCIRCLEs( BCIRCLE &a, BCIRCLE &b )
{
	VECTOR2		v_dist;

	// R̓_Ɠ_̋ŁAr
	v_dist = a.center - b.center;

	if ( SizeOfVector2( &v_dist) > a.radius + b.radius )
		return false;

	return true;
}

// AABB̌
bool IntersectAABRs( AABR &a, AABR &b )
{
	// `̔ɂ΂炷

	if ( a.minimum.x > b.maximum.x )	return false;
	if ( a.maximum.x < b.minimum.x )	return false;

	if ( a.minimum.y > b.maximum.y )	return false;
	if ( a.maximum.y < b.minimum.y )	return false;

	return true;
}

// OBB̌
bool IntersectOBRs( OBR &a, OBR &b )
{
	float			ra, rb;
	MATRIX2			R, absR;
	int				i, j;
	VECTOR2			t;

	// a̍Wnb\]svZ
	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			R.m[i][j] = DotProduct2( &a.axis[i], &b.axis[j] );
		}
	}

	// sړxNg
	t = b.center - a.center;

	// sړa̍Wn֎Ă
	t = VECTOR2(
		DotProduct2(&t,&a.axis[0]),
		DotProduct2(&t,&a.axis[1])
		);

	// ʂ̕\svZ
	for ( i = 0 ; i < 2 ; i++ )
	{
		for ( j = 0 ; j < 2 ; j++ )
		{
			absR.m[i][j] = _ABS_(R.m[i][j]);
		}
	}

	// eAL=A0, L=A1̎eXg
	for ( i = 0 ; i < 2 ; i++ )
	{
		ra = a.extent.m[i];
		rb = b.extent.x * absR.m[i][0] +
			b.extent.y * absR.m[i][1];
		if ( _ABS_(t.m[i]) > ra + rb )
			return false;
	}

	// eAL=B0, L=B1̎eXg
	for ( i = 0 ; i < 3 ; i++ )
	{
		ra = a.extent.x * absR.m[0][i] +
			a.extent.y * absR.m[1][i];
		rb = b.extent.m[i];
		if ( _ABS_( t.x*R.m[0][i]+t.y*R.m[1][i] ) > ra + rb )
			return false;
	}

	// intersecting
	return true;
}





/*=====================================================


				Z


=====================================================*/

// P̗zIϕ
// xFʒu
// vFx
// aFx
void ExplicitIntegral1( float *x, float *v, float a )
{
	*v += a;
	*x += *v;
}

// Q̗zIϕ
// xFʒu
// vFx
// aFx
void ExplicitIntegral2( VECTOR2 *x, VECTOR2 *v, VECTOR2 a )
{
//	*v = *v + a;
//	*x = *x + *v;
	*v += *v + a;
	*x += *x + *v;
}


// Փ˂ł́AUpxƂA߂B
// m1F˂ďՓ˂镨̂P̎
// m2FÎ~ĂďՓ˂镨̂Q̎
// phiFՓˑOɕ̂P˂ƁCՓˌɕ̂QUp
float GetThetaOfCollision( float m1, float m2, float phi )
{
	float x, y, theta;

	x = m1 - m2 * cosf( 2 * phi );
	y = m2 * sinf( 2 * phi );
	theta = atan2f( y, x );

	return theta;
}


// QŁC^Ă镨̂PƉ^Ă镨̂QA
// Փ˂̑x߂B
void GetVelocityOfCollision2( float m1, VECTOR2 pos1, VECTOR2 vel1, VECTOR2 *vel1_2,
							  float m2, VECTOR2 pos2, VECTOR2 vel2, VECTOR2 *vel2_2 )
{
	VECTOR2		vl;
	float		fRot;
	MATRIX2		matRot;
	VECTOR2		v1, v2;
	float		u1c, u2c;

	vl			= pos2 - pos1;
	vl			= NormalizeVector2( &vl );
	fRot		= atan2f( vl.y, vl.x );
	matRot		= MatrixRotation2( -fRot );
	v1			= vel1 * matRot;
	v2			= vel2 * matRot;
	u1c			= ((m1-m2)*v1.x+2.0F*m2*v2.x)/(m1+m2);
	u2c			= (2*m1*v1.x+(m2-m1)*v2.x)/(m1+m2);
	v1.x		= u1c;
	v2.x		= u2c;
	matRot		= MatrixRotation2( fRot );
	*vel1_2		= v1 * matRot;
	*vel2_2		= v2 * matRot;
}

void GetVelOfCol2( float m0, VECTOR2 vIn0, VECTOR2 *vOut0,
				  float m1, VECTOR2 vIn1, VECTOR2 *vOut1,
				  VECTOR2 n, float e )
{
	VECTOR2		vr;		// ̂P猩̂ȎΑx
	VECTOR2		J;		// ͐

	vr		= vIn0 - vIn1;
	J		= - vr * (e+1.0F) / (1.0F/m0 + 1.0F/m1);
	n		= NormalizeVector2( &n );
	J		= DotProduct2( &J, &n ) * n;


	*vOut0	= vIn0 + J / m0;
	*vOut1	= vIn1 - J / m1;
}






// Q̔˃xNgZo
// vNormalF@xNg
// vInF˃xNg
// ߂lF˃xNg
VECTOR2	ReflectionVector2( VECTOR2 vNormal, VECTOR2 vIn )
{
	VECTOR2		vOut;

	vOut = vIn - 
		 ( 2.0F * DotProduct2( &vIn, &vNormal ) / SizeSqOfVector2( &vNormal ) ) * vNormal;

	return vOut;
}


