/*********************************
		math2d_lib.h
		since 2004/12/18
		update 2006/02/20
*********************************/

// QdCN[hh~
#ifndef MATH2D_LIB_H
#define MATH2D_LIB_H


// CN[ḧ
#include <float.h>
#include <math.h>

#ifdef	PI
#undef PI
#endif


/*=====================================================


				}NAAZu


=====================================================*/
#ifndef _ABS_
#define _ABS_( x ) ((x>=0)?x:(-x))
#endif

#ifndef _EPSILON
#define _EPSILON	FLT_EPSILON
#endif

#ifdef __BORLANDC__

#define FASTCOSSIN( x, pCos, pSin )	\
{\
	*pCos	= cos( x );\
	*pSin	= sin( x );\
}

#define	sqrtf	sqrt
#define cosf	cos
#define sinf	sin
#define	atan2f	atan2

#else

// cossin𓯎ɋ߂AZu
#define FASTCOSSIN( x, pCos, pSin )	\
__asm {\
	__asm fld	x		\
	__asm mov	ecx,	dword ptr[pCos]	\
	__asm mov	eax,	dword ptr[pSin]	\
	__asm fsincos		\
	__asm fstp	dword ptr[ecx] \
	__asm fstp	dword ptr[eax] \
}

#endif



/*=====================================================


				QxNg


=====================================================*/

/////////////////////////////////////////
// NX錾

// QxNg(QcxNg)
class VECTOR2
{
public:
	union 
	{
		float		x, y;
		float		m[2];
	};

public:
	VECTOR2(){}
	VECTOR2( float X, float Y )
	{
		x = X;
		y = Y;
	}

	// QcxNg̘a( v0+v1 )
	VECTOR2 operator+ ( VECTOR2 v1 );

	// QcxNg̍( v0-v1 )
	VECTOR2 operator- ( VECTOR2 v1 );

	// QcxNg̃}CiX( -v )
	VECTOR2 operator - ();

	// ȗ`̃I[o[[h
	VECTOR2 operator += ( VECTOR2 b );
	VECTOR2 operator -= ( VECTOR2 b );


	// QcxNg̃XJ[{(va)
	VECTOR2 operator * ( float a );
	VECTOR2 operator *= ( float a );

	// QcxNg̃XJ[ɂ鏜Z( v/a )
	VECTOR2 operator / ( float a );
	VECTOR2 operator /= ( float a );
};

///////////////////////////////////////////////////////
// ֐vg^Cv


// QcxNg̃XJ[{(av)
VECTOR2 operator* ( float a, VECTOR2 &v );

// QcxNg̑傫
float SizeOfVector2( VECTOR2 *v );

// QcxNg̑傫̂Q
float SizeSqOfVector2( VECTOR2 *v );

// QcxNg̐K(PʃxNgɂB)
VECTOR2 NormalizeVector2( VECTOR2 *v );

// QcxNg̓( v0Ev1 )
float DotProduct2( VECTOR2 *v0, VECTOR2 *v1 );

// QcxNg̊O( v0~v1 )
float CrossProduct2( VECTOR2 *v0, VECTOR2 *v1 );
float operator * ( VECTOR2 &v0, VECTOR2 &v1 );

// QcxNgcos
float CosineTheta2( VECTOR2 *v0, VECTOR2 *v1 );

// QcxNgsin
float SineTheta2( VECTOR2 *v0, VECTOR2 *v1 );

// Qc̐ˉexNg( v0v1 )
VECTOR2 ProjectionVector2( VECTOR2 *v0, VECTOR2 *v1 );

// Qc̎ˉexNg( v0Av1ɐȃxNg߂B )
VECTOR2 PerpendicularVector2( VECTOR2 *v0, VECTOR2 *v1 );

// Qc̓_ƒ̋
// Fp = p0 + tu  _q ̋
float DistanceFromPointToLine2( VECTOR2 *q, VECTOR2 *p0, VECTOR2 *u );

// Qc̓_Ɛ̋
// Fv0  v1 ƁA_q ̋
float DistanceFromPointToLimitedLine2( VECTOR2 *q, VECTOR2 *v0, VECTOR2 *v1 );

// Qc̐xNg( vɐȃxNg )
VECTOR2 CrossVector2( VECTOR2 *v );

// QĉRp`̓
// p0, p1, p2 F Op`
// v : _
// ɂȂAtrue ԂBOȂAfalse ԂB
bool IsInsideTriangle2( VECTOR2 *p0, VECTOR2 *p1, VECTOR2 *p2, VECTOR2 *v );









/*=====================================================


				Qs


=====================================================*/

/////////////////////////////////////////
// NX錾

// Qs
class MATRIX2
{
public:
	float		m[2][2];

public:
	MATRIX2(){}
	MATRIX2( float _m00, float _m01,
			 float _m10, float _m11 )
	{
		m[0][0] = _m00;	m[0][1] = _m01;
		m[1][0] = _m10; m[1][1] = _m11;
	}
};


///////////////////////////////////////////////////////
// ֐vg^Cv

// Qs̘a( A + B )
MATRIX2 operator +( MATRIX2 A, MATRIX2 B );

// Qs̍( A - B )
MATRIX2 operator -( MATRIX2 A, MATRIX2 B );

// Qs̃}CiX( -A )
MATRIX2 operator - ( MATRIX2 &A );

// Qs̃XJ[{( aA )
MATRIX2 operator *( float a, MATRIX2 A );

// Qs̏Z( A~B )
MATRIX2 MatrixMultiply2( MATRIX2 &A, MATRIX2 &B );
MATRIX2 operator * ( MATRIX2 &A, MATRIX2 &B );

// PʂQsԂB
MATRIX2 MatrixIdentity2( void );

// Qs̓]us
MATRIX2 MatrixTranspose2( MATRIX2 A );

// Qs̍s
float MatrixDeterminant2( MATRIX2 A );

// Qs̋ts
MATRIX2 MatrixInverse2( MATRIX2 A );
MATRIX2 operator ~( MATRIX2 &A );





/*=====================================================


				Rs


=====================================================*/

/////////////////////////////////////////
// NX錾


// Rs
class MATRIX3
{
public:
	float		m[3][3];

public:
	MATRIX3(){}
	MATRIX3( float _m00, float _m01, float _m02,
				float _m10, float _m11, float _m12,
				float _m20, float _m21, float _m22 )
	{
		m[0][0] = _m00; m[0][1] = _m01; m[0][2] = _m02;
		m[1][0] = _m10; m[1][1] = _m11; m[1][2] = _m12;
		m[2][0] = _m20; m[2][1] = _m21; m[2][2] = _m22;
	}
};

///////////////////////////////////////////////////////
// ֐vg^Cv

// Rs̘a( A + B )
MATRIX3 operator +( MATRIX3 A, MATRIX3 B );

// Rs̍( A - B )
MATRIX3 operator -( MATRIX3 A, MATRIX3 B );

// Rs̃}CiX( -A )
MATRIX3 operator - ( MATRIX3 &A );

// Rs̃XJ[{( aA )
MATRIX3 operator *( float a, MATRIX3 A );

// Rs̏Z( A~B )
MATRIX3 MatrixMultiply3( MATRIX3 &A, MATRIX3 &B );
MATRIX3 operator * ( MATRIX3 &A, MATRIX3 &B );

// PʂRsԂB
MATRIX3 MatrixIdentity3( void );

// Rs̓]us
MATRIX3 MatrixTranspose3( MATRIX3 A );

// Rs̍s
float MatrixDeterminant3( MATRIX3 A );

// Rs̋ts
MATRIX3 MatrixInverse3( MATRIX3 A );
MATRIX3 operator ~( MATRIX3 &A );




/*=====================================================


				ϊ


=====================================================*/

///////////////////////////////////////////////////////
// ֐vg^Cv

// QxNg~Qs
VECTOR2 MultiplyVectorByMatrix2( VECTOR2 &v, MATRIX2 &m );
VECTOR2 operator * ( VECTOR2 &v, MATRIX2 &m );

// QxNg̃AtBϊ
VECTOR2 AffineTransform2( VECTOR2 &v, MATRIX3 &m );
VECTOR2 operator *( VECTOR2 &v, MATRIX3 &m );

// Q̃XP[Os
// sx : ̃XP[O
// sy : ̃XP[O
// XP[OsԂ
MATRIX2 MatrixScale2( float sx, float sy );

// Q̉]s
MATRIX2 MatrixRotation2( float theta );

// Q̕sړs
MATRIX3 MatrixTranslate2( VECTOR2 trans );

// Q̃AtBϊs𐶐
MATRIX3 MatrixAffine2( MATRIX2 m, VECTOR2 trans );

// Q̂sqrϊs쐬
// XP[O~]s~sړs
// sx : XP[O
// sy : XP[O
// theta : ]p
// trans : sړ
MATRIX3 MatrixTRS2( float sx, float sy, float theta, VECTOR2 trans );

// Q̐ˉes
MATRIX2 MatrixProjection2( VECTOR2 a );

// Kspĉ]s쐬B
// xNg̕ɉ]s
// toward : ÕxNg
// right : ̉Ẽ̕xNg
// Ftoward̕ցAE̕ɌB
MATRIX2 MatrixToward2( VECTOR2 toward, VECTOR2 right );




/*=====================================================


			AȐ̕


=====================================================*/

///////////////////////////////////////////////////////
// ֐vg^Cv

// ̕
// v0, v1F[_w肷
// tFp[^(O`P)w肷
// ߂lFԂꂽxNg(Q)
VECTOR2 VectorLerp2( VECTOR2 v0, VECTOR2 v1, float t );

// ܂̕
// numF_̌
// pVF_̔zw肷
// tFp[^(O`num-1)w肷
// t̒lFO`PPڂƂQڂԂA
// @@@ @P`QQڂƂRڂԂ
// ߂lFԂꂽxNg(Q)
VECTOR2 VectorLerps2( int num, VECTOR2 *pV, float t );

// OWF
// numF_̌w肷
// pX, pYF_̂W̔zAyтW̔zw肷
// XFWw肷
// ߂lFXŎw肳ꂽxWɑΉyWԂ
float Lagurange( int num, float *pX, float *pY, float X );

// Lg}ȐԁiCC)
// x0 : x1 O̒l
// x1 : Pڂ̒[_
// x2 : Qڂ̒[_
// x3 : x2 ̒l
// t : p[^( 0 ` 1 w肷)
// ߂lFx0  x1 ̊ԂŁAtƂɕԂlԂ
inline float CatmullRom1( float x0, float x1, float x2, float x3, float t )
{
	float	t2, t3;

	t2		= t * t;
	t3		= t2 * t;
	
	return x0 * ( - 0.5F * t3 + t2 - 0.5F * t ) +
		x1 * ( 1.5F * t3 - 2.5F * t2 + 1.0F ) +
		x2 * ( -1.5F * t3 + 2.0F * t2 + 0.5F * t ) +
		x3 * ( 0.5F * t3 - 0.5F * t2 );
}

// Lg}Ȑ
// pVFQ̒[_̈ʒuxNgw肷
// pV2FQ̒[_̐̒[_̈ʒuxNgw肷
// tFp[^(O`P)w肷
// ߂lFԂꂽxNg(Q)
VECTOR2 CatmullRom2( VECTOR2 pV[2], VECTOR2 pV2[2], float t );

// A_̃Lg}Ȑ
// numFžw肷
// pVF[_̈ʒuxNg̔zw肷
// tFp[^(O`num-1)w肷
// t̒lFO`PPڂƂQڂԂA
// @@@ @P`QQڂƂRڂԂ
// ߂lFԂꂽxNg(Q)
VECTOR2 CatmullRoms2( int num, VECTOR2 *pV, float t, bool bLoop );



/*=====================================================


				E{[


=====================================================*/

///////////////////////////////////////////////////
// NX錾

// O錾
class OBR;

// E~(oEfBOET[N)
class BCIRCLE
{
public:
	VECTOR2		center;	// S
	float		radius; // a
public:
	BCIRCLE(){}
	BCIRCLE( VECTOR2 c, float r )
	{
		center	= c;
		radius	= r;
	}
};

// sE`(ANVXEAChEoEfBOENg)
class AABR
{
public:
	VECTOR2		minimum;	// W̒_
	VECTOR2		maximum;	// 傫W̒_
public:
	AABR(){}
	AABR( VECTOR2 min, VECTOR2 max )
	{
		minimum		= min;
		maximum		= max;
	}
	operator OBR();
};

// Cӂ̌̋E`(IGeBbhEoEfBOENg)
class OBR
{
public:
	VECTOR2		center;		// OBR̒S
	VECTOR2		axis[2];	// [Jx, y
	VECTOR2		extent;		// eɉOBR̔̒(̒l)
public:
	OBR(){}
	OBR( VECTOR2 c, VECTOR2 a[3], VECTOR2 e )
	{
		int			i;

		center		= c;
		for ( i = 0 ; i < 3 ; i++ )
		{
			axis[i]		= a[i];
		}
		extent		= e;
	}
};


///////////////////////////////////////////////////////
// ֐vg^Cv

// OBR̕ϊ
OBR OBRMultiplyByMatrix3( OBR &box, MATRIX3 &mat );
OBR operator * ( OBR &box, MATRIX3 &mat );

// BCIRCLĚ
bool IntersectBCIRCLEs( BCIRCLE &a, BCIRCLE &b );

// AABB̌
bool IntersectAABRs( AABR &a, AABR &b );

// OBŘ
bool IntersectOBRs( OBR &a, OBR &b );




/*=====================================================


				Z


=====================================================*/

// P̗zIϕ
// xFʒu
// vFx
// aFx
void ExplicitIntegral1( float *x, float *v, float a );

// Q̗zIϕ
// xFʒu
// vFx
// aFx
void ExplicitIntegral2( VECTOR2 *x, VECTOR2 *v, VECTOR2 a );

// QŁC^Ă镨̂PƉ^Ă镨̂QA
// Փ˂̑x߂B
// m1 : ̂P̎
// pos1 : ̂P̈ʒuxNg
// vel1 : ̂P̓ˑxxNg
// vel1_2(߂l) : ̂P̏Փˌ̑xxNgւ̃|C^
// m2 : ̂Q̎
// pos2 : ̂Q̈ʒuxNg
// vel2 : ̂Q̓ˑxxNg
// vel2_2(߂l) : ̂Q̏Փˌ̑xxNgւ̃|C^
void GetVelocityOfCollision2( float m1, VECTOR2 pos1, VECTOR2 vel1, VECTOR2 *vel1_2,
							   float m2, VECTOR2 pos2, VECTOR2 vel2, VECTOR2 *vel2_2 );

void GetVelOfCol2( float m0, VECTOR2 vIn0, VECTOR2 *vOut0,
				  float m1, VECTOR2 vIn1, VECTOR2 *vOut1,
				  VECTOR2 n, float e );

// Q̔˃xNgZo
// vNormalF@xNg
// vInF˃xNg
// ߂lF˃xNg
VECTOR2	ReflectionVector2( VECTOR2 vNormal, VECTOR2 vIn );



#endif // end of MATH2D_LIB_H